src/Entity/QuoteGeneration.php
<?php

namespace App\Entity;

use App\Repository\QuoteGenerationRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=QuoteGenerationRepository::class)
 * @ORM\Table(name="sp_quote_generation")
 */
class QuoteGeneration
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="text")
     */
    private $html;

    /**
     * @ORM\Column(type="boolean")
     */
    private $is_ordered;

    /**
     * @ORM\Column(type="datetime")
     */
    private $created_at;

    /**
     * @ORM\OneToOne(targetEntity=Ticket::class, inversedBy="quoteGeneration", cascade={"persist", "remove"})
     * @ORM\JoinColumn(name="ticket_id", referencedColumnName="id", nullable=true)
     */
    private $ticket;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="generation_from")
     */
    private $client;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="generation_to")
     */
    private $provider;

    /**
     * @ORM\OneToMany(targetEntity=QuoteItem::class, mappedBy="quote_generation", cascade={"persist", "remove"}, orphanRemoval=true)
     */
    private $items;

    /**
     * @ORM\Column(type="float")
     */
    private $amount = 0;

    /**
     * @ORM\ManyToOne(targetEntity=Company::class, inversedBy="quoteGenerations")
     */
    private $company;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getHtml(): ?string
    {
        return $this->html;
    }

    public function setHtml(string $html): self
    {
        $this->html = $html;

        return $this;
    }

    public function getIsOrdered(): ?bool
    {
        return $this->is_ordered;
    }

    public function setIsOrdered(bool $is_ordered): self
    {
        $this->is_ordered = $is_ordered;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->created_at;
    }

    public function setCreatedAt(\DateTimeInterface $created_at): self
    {
        $this->created_at = $created_at;

        return $this;
    }

    public function getTicket(): ?Ticket
    {
        return $this->ticket;
    }

    public function setTicket(?Ticket $ticket): self
    {
        $this->ticket = $ticket;

        return $this;
    }

    public function getClient(): ?User
    {
        return $this->client;
    }

    public function setClient(?User $client): self
    {
        $this->client = $client;

        return $this;
    }

    public function getProvider(): ?User
    {
        return $this->provider;
    }

    public function setProvider(?User $provider): self
    {
        $this->provider = $provider;

        return $this;
    }

    public function __construct()
    {
        $this->is_ordered = false;
        $this->created_at = new \DateTime();
        $this->items = new ArrayCollection();
    }

    /**
     * @return Collection|QuoteItem[]
     */
    public function getItems(): Collection
    {
        return $this->items;
    }

    public function addItem(QuoteItem $item): self
    {
        if (!$this->items->contains($item)) {
            $this->items[] = $item;
            $item->setQuoteGeneration($this);
        }

        return $this;
    }

    public function removeItem(QuoteItem $item): self
    {
        if ($this->items->removeElement($item)) {
            // set the owning side to null (unless already changed)
            if ($item->getQuoteGeneration() === $this) {
                $item->setQuoteGeneration(null);
            }
        }

        return $this;
    }

    public function getAmount(): ?float
    {
        return $this->amount;
    }

    public function setAmount(float $amount): self
    {
        $this->amount = $amount;

        return $this;
    }

    public function getCompany(): ?Company
    {
        return $this->company;
    }

    public function setCompany(?Company $company): self
    {
        $this->company = $company;

        return $this;
    }
}

src/Form/QuoteGenerationType.php
<?php

namespace App\Form;

use App\Entity\QuoteGeneration;
use App\Entity\QuoteItem;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class QuoteGenerationType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('items', CollectionType::class, [
                'entry_type' => QuoteItemType::class,
                'allow_add' => true,
                'allow_delete' => true,
                'prototype' => true,
                'required' => false,
                'by_reference' => false,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => QuoteGeneration::class,
        ]);
    }
}

src/Controller/QuoteGenerationController.php
<?php

namespace App\Controller;

use App\Entity\Product;
use App\Entity\QuoteGeneration;
use App\Form\QuoteGenerationType;
use App\Repository\QuoteGenerationRepository;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;

/**
 * @Route("/dashboard/quote/generation")
 */
class QuoteGenerationController extends AbstractController
{
    /**
     * @Route("/", name="dashboard_quote_generation_index", methods={"GET"})
     * @param Request $request
     * @param QuoteGenerationRepository $quoteGenerationRepository
     * @param PaginatorInterface $paginator
     * @return Response
     */
    public function index(Request $request, QuoteGenerationRepository $quoteGenerationRepository, PaginatorInterface $paginator): Response
    {
        if ($this->isGranted('ROLE_ADMIN')) {
            $quote_generations = $quoteGenerationRepository->findAll();
        } else {
            $quote_generations = $quoteGenerationRepository->findBy(["provider" => $this->getUser()], ["id" => "DESC"]);
        }

        $quote_generations = $paginator->paginate(
            $quote_generations,
            $request->query->getInt('page', 1),
            20
        );

        return $this->render('quote_generation/index.html.twig', [
            'quote_generations' => $quote_generations,
        ]);
    }

    /**
     * @Route("/new", name="dashboard_quote_generation_new", methods={"GET","POST"})
     * @param Request $request
     * @return Response
     */
    public function new(Request $request): Response
    {
        $quoteGeneration = new QuoteGeneration();
        $form = $this->createForm(QuoteGenerationType::class, $quoteGeneration);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($quoteGeneration);
            $entityManager->flush();

            return $this->redirectToRoute('dashboard_quote_generation_index');
        }

        return $this->render('quote_generation/new.html.twig', [
            'quote_generation' => $quoteGeneration,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/product-price", name="dashboard_get_product_price", methods={"POST"})
     * @param Request $request
     * @return Response
     */
    public function getProductPrice(Request $request)
    {
        $data = $request->request->all();
        $id = (int) $data['id'];

        $product = $this->getDoctrine()->getManager()->getRepository(Product::class)->find($id);
        if ($product) {
            $price = $product->getPrice();
        } else {
            $price = 0;
        }

        return new Response($price, 200);
    }

    /**
     * @Route("/{id}", name="dashboard_quote_generation_show", methods={"GET"})
     * @param QuoteGeneration $quoteGeneration
     * @return Response
     */
    public function show(QuoteGeneration $quoteGeneration): Response
    {
        return $this->render('quote_generation/show.html.twig', [
            'quote_generation' => $quoteGeneration,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="dashboard_quote_generation_edit", methods={"GET","POST"})
     * @param Request $request
     * @param QuoteGeneration $quoteGeneration
     * @return Response
     */
    public function edit(Request $request, QuoteGeneration $quoteGeneration): Response
    {
        $form = $this->createForm(QuoteGenerationType::class, $quoteGeneration);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $html = $this->getQuoteHtml($quoteGeneration);
            $quoteGeneration->setHtml($html);

            $amount = 0;
            $items = $quoteGeneration->getItems();
            foreach ($items as $item) {
                $product = $item->getProduct();
                $amount += $product->getPrice();
            }
            $quoteGeneration->setAmount($amount);

            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('dashboard_quote_generation_index');
        }

        return $this->render('quote_generation/edit.html.twig', [
            'quote_generation' => $quoteGeneration,
            'form' => $form->createView(),
        ]);
    }

    private function getQuoteHtml(QuoteGeneration $quoteGeneration)
    {
        $em = $this->getDoctrine()->getManager();
        $html = '';
        $total = 0;
        $user = $quoteGeneration->getClient();
        $provider = $quoteGeneration->getProvider();
        $company = $quoteGeneration->getCompany();

        if ($company) {
            $clientName = $company->getName();
            $clientVat = $company->getVatNumber();
            $clientAddress = $company->getAddress();
        } else {
            $clientName = $user->getName();
            $clientVat = "-";
            $clientAddress = $user->getAddress();
        }

            // Header
            $imgSprindt = '/style/images/logo.png';
            $img = $provider->getLogoUrl();
            $date = new \DateTime();
            $date = $date->format('d/m/Y');

            $html .= '
            <table width="100%" class="nbd">
                <tr>
                    <td valign="middle" align="left">
                        <br><br>
                        <img src="' . $img . '" width="100" alt="logo" class="logo-provider">
                    </td>
                    <td valign="middle" align="right">
                        <table width="100%" class="nbd">
                            <tr>
                                <td valign="middle" align="right">
                                    <strong>Date</strong> : ' . $date . '
                                    <br>
                                    <br>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <table border="1" width="100%" cellpadding="5" class="bordered-custom-table">
                                        <tr>
                                            <td align="left">Nom/Raison sociale</td>
                                            <td align="center">' . $company->getName() . '</td>
                                        </tr>
                                        <tr>
                                            <td align="left">M.Fiscale</td>
                                            <td align="center">' . $company->getVatNumber() . '</td>
                                        </tr>
                                        <tr>
                                            <td align="left">Adresse</td>
                                            <td align="center">' . $company->getAddress() . '</td>
                                        </tr>
                                    </table>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td>
                        
                    </td>
                    <td valign="middle" align="right">
                        <br><br><br>
                        <h2 style="text-align: center">À l\'attention de</h2>
                        <br>
                        <table border="1" width="100%" cellpadding="5" class="bordered-custom-table">
                            <tr>
                                <td align="left">Nom</td>
                                <td align="center">' . $clientName . '</td>
                            </tr>
                            <tr>
                                <td align="left">M.Fiscale</td>
                                <td align="center">' . $clientVat . '</td>
                            </tr>
                            <tr>
                                <td align="left">Adresse</td>
                                <td align="center">' . $clientAddress . '</td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            <br><br><br><br><br>
        ';

            $html .= '
            <table width="100%" class="nbd">
                <tr>
                    <td align="center">
                        <h2>Prototype de devis</h2>
                        <br>
                    </td>
                </tr>
            </table>';

            $html .= '<table border="1" width="100%" cellpadding="5" class="bordered-custom-table">';
            $html .= '
                <tr>
                    <td width="55%" valign="middle" align="left"><strong>DESCRIPTION</strong></td>
                    <td width="15%" valign="middle" align="right"><strong>QUANTITE</strong></td>
                    <td width="15%" valign="middle" align="right"><strong>P.U HT</strong></td>
                    <td width="15%" valign="middle" align="right"><strong>MONTANT HT</strong></td>
                </tr>
        ';

            $items = $quoteGeneration->getItems();
            foreach ($items as $item) {
                $product = $item->getProduct();
                $html .= '
                    <tr>
                        <td valign="top" align="left">' . $product->getDescription() . '</td>
                        <td valign="top" align="right">
                            ' . $item->getQuantity() . '
                            <br><br><br><br><br><br><br><br>
                        </td>
                        <td valign="top" align="right">' . $item->getUnitPrice() . '</td>';

templates/quote_generation/_delete_form.html.twig
<form method="post" action="{{ path('quote_generation_delete', {'id': quote_generation.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ quote_generation.id) }}">
    <button class="btn">Delete</button>
</form>

templates/quote_generation/_form.html.twig
{% macro printFormRow(form) %}
    <td class="text-center">
        <a href="#" class="btn btn-danger js-remove-item">-</a>
    </td>
    <td>
        {{ form_widget(form.product, {attr: {class: 'select2 form-control'}}) }}
        {{ form_errors(form.product) }}
    </td>
    <td>
        {{ form_widget(form.quantity, {attr: {class: 'form-control'}}) }}
        {{ form_errors(form.quantity) }}
    </td>
    <td>
        {{ form_widget(form.unit_price, {attr: {class: 'form-control form-price'}}) }}
        {{ form_errors(form.unit_price) }}
    </td>
{% endmacro %}

{% import _self as formMacros %}

{{ form_start(form) }}

{#{% if is_granted('ROLE_ADMIN') %}
<div class="form-group">
    {{ form_label(form.client) }}
    {{ form_widget(form.client, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.client) }}
</div>
<div class="form-group">
    {{ form_label(form.provider) }}
    {{ form_widget(form.provider, {attr: {class: 'form-control'}}) }}
    {{ form_errors(form.provider) }}
</div>
{% endif %}#}

<table class="table">
    <thead>
    <tr>
        <th class="text-center">#</th>
        <th width="70%">Produit</th>
        <th>Quantité</th>
        <th>Prix unitaire</th>
    </tr>
    </thead>
    <tbody id="item-fields-list" class="js-items-wrapper"
           data-prototype="{{ formMacros.printFormRow(form.items.vars.prototype)|e('html_attr') }}"
           data-widget-tags="{{ '<tr class="js-item-row"></tr>'|e }}"
           data-widget-counter="{{ form.items|length }}">
    {% for itemField in form.items %}
        <tr class="js-item-row">
            <td class="text-center">
                <a href="#" class="btn btn-danger js-remove-item">-</a>
            </td>
            <td>
                {{ form_widget(itemField.product, {attr: {class: 'select2 form-control'}}) }}
                {{ form_errors(itemField.product) }}
            </td>
            <td>
                {{ form_widget(itemField.quantity, {attr: {class: 'form-control'}}) }}
                {{ form_errors(itemField.quantity) }}
            </td>
            <td>
                {{ form_widget(itemField.unit_price, {attr: {class: 'form-control form-price'}}) }}
                {{ form_errors(itemField.unit_price) }}
            </td>
        </tr>
    {% endfor %}
    </tbody>
</table>
<p style="padding-top: 0 !important;" class="p-3">
    <a href="#" data-list-selector="#item-fields-list" class="add-another-collection-widget btn btn-success">+</a>
</p>

<button class="btn btn-primary">Modifier le devis</button>

{{ form_end(form, {'render_rest': false}) }}

templates/quote_generation/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit QuoteGeneration{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header">
            <h1 class="card-title float-left">Modification du devis</h1>
            <p class="float-right m-0">
                <a class="btn btn-sm btn-info" href="{{ path('dashboard_quote_generation_index') }}">Revenir à la liste</a>
            </p>
            <div class="clearfix"></div>
        </div>
        <div class="card-body">
            {{ include('quote_generation/_form.html.twig', {'button_label': 'Update'}) }}
        </div>
    </div>
{% endblock %}

{% block javascripts %}
    <script>
        jQuery(document).ready(function () {
            jQuery('.add-another-collection-widget').click(function (e) {
                e.preventDefault();

                let list = jQuery(jQuery(this).attr('data-list-selector'));
                let counter = list.data('widget-counter') || list.children().length;

                let newWidget = list.attr('data-prototype');
                newWidget = newWidget.replace(/__name__/g, counter);
                counter++;
                list.data('widget-counter', counter);

                let newElem = jQuery(list.attr('data-widget-tags')).html(newWidget);
                newElem.appendTo(list);

                $('.select2').select2();
                updateOnSelectChange();
            });

            let $wrapper = $('.js-items-wrapper');
            $wrapper.on('click', '.js-remove-item', function(e) {
                e.preventDefault();
                $(this).closest('.js-item-row').fadeOut().remove();
            });

            updateOnSelectChange();

            function updateOnSelectChange()
            {
                $('select').on('select2:select', function () {
                    let $select = $(this);
                    $.ajax({
                        url: '{{ path('dashboard_get_product_price') }}',
                        type: "post",
                        data: {id: $(this).val()}
                    }).done(function (jqxhr) {
                        let $parent = $select.parent().parent();
                        $('input', $parent).val(1);
                        $('.form-price', $parent).val(jqxhr);
                    })
                })
            }
        });
    </script>
{% endblock %}

{% block stylesheets %}
    <style>
        .select2-container {
            width: 100% !important;
        }
    </style>
{% endblock %}

templates/quote_generation/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}QuoteGeneration index{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header"><h1 class="card-title">Liste des devis générés</h1></div>
        <div class="card-body">
            <table class="table">
                <thead>
                <tr>
                    <th>#</th>
                    <th>Client</th>
                    {% if is_granted('ROLE_ADMIN') %}
                    <th>Fournisseur</th>
                    {% endif %}
                    <th>Date de création</th>
                    <th>Montant</th>
                    <th>Achat demandé</th>
                    <th>Actions</th>
                </tr>
                </thead>
                <tbody>
                {% for quote_generation in quote_generations %}
                    <tr>
                        <td>{{ quote_generation.id }}</td>
                        <td>{{ quote_generation.client }}</td>
                        {% if is_granted('ROLE_ADMIN') %}
                            <td>{{ quote_generation.provider }}</td>
                        {% endif %}
                        <td>{{ quote_generation.createdAt ? quote_generation.createdAt|date('d/m/Y') : '' }}</td>
                        <td>{{ quote_generation.amount }} TND</td>
                        <td>
                            {% if quote_generation.isOrdered %}
                                <span class="badge badge-success">&nbsp; Oui &nbsp;</span>
                            {% else %}
                                <span class="badge badge-info">&nbsp; Non &nbsp;</span>
                            {% endif %}
                        </td>
                        <td>
                            <a class="btn btn-sm btn-primary" href="{{ path('dashboard_quote_generation_show', {'id': quote_generation.id}) }}"><i class="fa fa-eye"></i></a>
                            <a class="btn btn-sm btn-success" href="{{ path('dashboard_quote_generation_edit', {'id': quote_generation.id}) }}"><i class="fa fa-edit"></i> modifier</a>
                        </td>
                    </tr>
                {% else %}
                    <tr>
                        <td colspan="5">no records found</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
            <div class="navigation">
                {{ knp_pagination_render(quote_generations) }}
            </div>
        </div>
    </div>
{% endblock %}

templates/quote_generation/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New QuoteGeneration{% endblock %}

{% block body %}
    <h1>Create new QuoteGeneration</h1>

    {{ include('quote_generation/_form.html.twig') }}

    <a href="{{ path('quote_generation_index') }}">back to list</a>
{% endblock %}

templates/quote_generation/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}QuoteGeneration{% endblock %}

{% block body %}
    <div class="card">
        <div class="card-header">
            <h1 class="card-title">Devis #{{ quote_generation.id }}</h1>
            {% if quote_generation.ticket %}
                <span class="badge badge-success">Achat demandé</span>
            {% else %}
                <span class="badge badge-secondary">Achat non demandé</span>
            {% endif %}
        </div>
        <div class="card-body">
            <p class="text-right">
                <a class="btn btn-primary" href="{{ path('dashboard_quote_generation_edit', {'id': quote_generation.id}) }}"><i class="fa fa-edit"></i> Modifier</a>
            </p>
            <div>
                {{ quote_generation.html|raw }}
            </div>
        </div>
    </div>
{% endblock %}